link-vmlinux.sh 6.8 KB
Newer Older
1
#!/bin/sh
2
# SPDX-License-Identifier: GPL-2.0
3 4 5
#
# link vmlinux
#
6 7 8 9 10
# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
# (not within --whole-archive), and do not require symbol indexes added.
11 12 13 14
#
# vmlinux
#   ^
#   |
15 16
#   +--< $(KBUILD_VMLINUX_OBJS)
#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17
#   |
18 19 20
#   +--< $(KBUILD_VMLINUX_LIBS)
#   |    +--< lib/lib.a + more
#   |
21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37
#   +-< ${kallsymso} (see description in KALLSYMS section)
#
# vmlinux version (uname -v) cannot be updated during normal
# descending-into-subdirs phase since we do not yet know if we need to
# update vmlinux.
# Therefore this step is delayed until just before final link of vmlinux.
#
# System.map is generated to document addresses of all kernel symbols

# Error out on error
set -e

# Nice output in kbuild format
# Will be supressed by "make -s"
info()
{
	if [ "${quiet}" != "silent_" ]; then
38
		printf "  %-7s %s\n" "${1}" "${2}"
39 40 41 42 43 44 45
	fi
}

# Link of vmlinux.o used for section mismatch analysis
# ${1} output file
modpost_link()
{
46 47
	local objects

48
	objects="--whole-archive				\
49
		${KBUILD_VMLINUX_OBJS}				\
50 51 52 53 54
		--no-whole-archive				\
		--start-group					\
		${KBUILD_VMLINUX_LIBS}				\
		--end-group"

55
	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${objects}
56 57 58 59 60 61 62 63
}

# Link of vmlinux
# ${1} - optional extra .o files
# ${2} - output file
vmlinux_link()
{
	local lds="${objtree}/${KBUILD_LDS}"
64
	local objects
65 66

	if [ "${SRCARCH}" != "um" ]; then
67
		objects="--whole-archive			\
68
			${KBUILD_VMLINUX_OBJS}			\
69 70 71 72 73
			--no-whole-archive			\
			--start-group				\
			${KBUILD_VMLINUX_LIBS}			\
			--end-group				\
			${1}"
74

75
		${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux} -o ${2}	\
76
			-T ${lds} ${objects}
77
	else
78
		objects="-Wl,--whole-archive			\
79
			${KBUILD_VMLINUX_OBJS}			\
80 81 82 83 84
			-Wl,--no-whole-archive			\
			-Wl,--start-group			\
			${KBUILD_VMLINUX_LIBS}			\
			-Wl,--end-group				\
			${1}"
85

86 87 88
		${CC} ${CFLAGS_vmlinux} -o ${2}			\
			-Wl,-T,${lds}				\
			${objects}				\
89
			-lutil -lrt -lpthread
90 91 92 93
		rm -f linux
	fi
}

94 95 96 97 98
# generate .BTF typeinfo from DWARF debuginfo
gen_btf()
{
	local pahole_ver;

99 100 101 102 103
	if ! [ -x "$(command -v ${PAHOLE})" ]; then
		info "BTF" "${1}: pahole (${PAHOLE}) is not available"
		return 0
	fi

104 105 106
	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
	if [ "${pahole_ver}" -lt "113" ]; then
		info "BTF" "${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.13"
107
		return 0
108 109 110 111 112
	fi

	info "BTF" ${1}
	LLVM_OBJCOPY=${OBJCOPY} ${PAHOLE} -J ${1}
}
113 114 115 116 117 118 119 120

# Create ${2} .o file with all symbols from the ${1} object file
kallsyms()
{
	info KSYM ${2}
	local kallsymopt;

	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
121
		kallsymopt="${kallsymopt} --all-symbols"
122 123
	fi

124
	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
125 126 127
		kallsymopt="${kallsymopt} --absolute-percpu"
	fi

128 129 130 131
	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
		kallsymopt="${kallsymopt} --base-relative"
	fi

S
Sam Ravnborg 已提交
132 133
	local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL}               \
		      ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
134

135 136 137 138
	local afile="`basename ${2} .o`.S"

	${NM} -n ${1} | scripts/kallsyms ${kallsymopt} > ${afile}
	${CC} ${aflags} -c -o ${2} ${afile}
139 140 141 142 143 144 145 146 147
}

# Create map file with all symbols from ${1}
# See mksymap for additional details
mksysmap()
{
	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
}

148 149 150 151 152
sortextable()
{
	${objtree}/scripts/sortextable ${1}
}

153 154 155 156 157 158 159 160 161 162 163
# Delete output files in case of error
cleanup()
{
	rm -f .tmp_System.map
	rm -f .tmp_kallsyms*
	rm -f .tmp_vmlinux*
	rm -f System.map
	rm -f vmlinux
	rm -f vmlinux.o
}

164 165 166 167 168 169 170 171 172 173 174 175 176 177
on_exit()
{
	if [ $? -ne 0 ]; then
		cleanup
	fi
}
trap on_exit EXIT

on_signals()
{
	exit 1
}
trap on_signals HUP INT QUIT TERM

178 179 180 181 182 183 184 185 186 187 188 189 190 191 192
#
#
# Use "make V=1" to debug this script
case "${KBUILD_VERBOSE}" in
*1*)
	set -x
	;;
esac

if [ "$1" = "clean" ]; then
	cleanup
	exit 0
fi

# We need access to CONFIG_ symbols
193
. include/config/auto.conf
194 195 196

# Update version
info GEN .version
197 198 199
if [ -r .version ]; then
	VERSION=$(expr 0$(cat .version) + 1)
	echo $VERSION > .version
200
else
201 202
	rm -f .version
	echo 1 > .version
203 204 205
fi;

# final build of init/
206
${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
207

208 209 210 211 212
#link vmlinux.o
info LD vmlinux.o
modpost_link vmlinux.o

# modpost vmlinux.o to check for section mismatches
213
${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
214

215 216 217
info MODINFO modules.builtin.modinfo
${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo

218 219 220 221 222 223 224 225 226 227 228 229 230 231 232
kallsymso=""
kallsyms_vmlinux=""
if [ -n "${CONFIG_KALLSYMS}" ]; then

	# kallsyms support
	# Generate section listing all symbols and add it into vmlinux
	# It's a three step process:
	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
	#     but __kallsyms is empty.
	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
	#     the right size
	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
	#     the right size, but due to the added section, some
	#     addresses have shifted.
	#     From here, we generate a correct .tmp_kallsyms2.o
233 234 235 236 237 238 239 240
	# 3)  That link may have expanded the kernel image enough that
	#     more linker branch stubs / trampolines had to be added, which
	#     introduces new names, which further expands kallsyms. Do another
	#     pass if that is the case. In theory it's possible this results
	#     in even more stubs, but unlikely.
	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
	#     other bugs.
	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
241 242 243 244 245 246 247 248 249 250 251 252 253 254 255
	#
	# a)  Verify that the System.map from vmlinux matches the map from
	#     ${kallsymso}.

	kallsymso=.tmp_kallsyms2.o
	kallsyms_vmlinux=.tmp_vmlinux2

	# step 1
	vmlinux_link "" .tmp_vmlinux1
	kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o

	# step 2
	vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
	kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o

256
	# step 3
257 258
	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms1.o)
	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" .tmp_kallsyms2.o)
259 260

	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
261 262 263 264 265 266 267 268 269 270 271 272
		kallsymso=.tmp_kallsyms3.o
		kallsyms_vmlinux=.tmp_vmlinux3

		vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3

		kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
	fi
fi

info LD vmlinux
vmlinux_link "${kallsymso}" vmlinux

273 274 275 276
if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
	gen_btf vmlinux
fi

277 278 279 280 281
if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
	info SORTEX vmlinux
	sortextable vmlinux
fi

282 283 284 285 286 287 288 289
info SYSMAP System.map
mksysmap vmlinux System.map

# step a (see comment above)
if [ -n "${CONFIG_KALLSYMS}" ]; then
	mksysmap ${kallsyms_vmlinux} .tmp_System.map

	if ! cmp -s System.map .tmp_System.map; then
M
Michal Marek 已提交
290
		echo >&2 Inconsistent kallsyms data
291
		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
292 293 294
		exit 1
	fi
fi